<?php
/*
 * SpamValve 1.0
 *
 * svupdate: updates IP activity entries in a database
 *
 * Usage: ipupdate <ip number> [delete]
 *
 *
 * License: GPL <http//www.fsf.org/licensing/licenses/gpl.html>
 * Copyright 2005, Dougal Campbell <dougal@gunters.org>
 * http://dougal.gunters.org/
 */

/*
 ******* THIS CODE IS UNFINISHED *******
 *
 * I started converting the 'ipupdate' perl script to PHP,
 * but I'm not done yet.
 *
 * Feel free to finish it and uncomment it
 *
 * ...

// Grab the arguments
$ipnum = shift @ARGV;
$delete = shift @ARGV;

$action = '';

// If the second argument is the word 'delete' (and nothing else),
// set the delete flag:
$delete = ('delete' == $delete)?1:0;
if ($delete) {
	$action = "Deleting";
} else {
	$action = "Blocking";
}

// IP number regex from http://www.regular-expressions.info/examples.html
die("'$ipnum' is not a valid IP number.\n") unless $ipnum =~ m/\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b/;

// These are regexes for IP numbers that we shouldn't mess with.
$ignore = (
	'^127\.0\.0\.1', # Don't block self, no matter what!
	'^70\.96\.227\.', # Ditto for local network.
	'^10\.', # Reserved
	'^172\.(1[6-9]|2[0-9]|3[01])\.', # Reserved
	'^192\.168\.', # Reserved
	);

foreach ($ignore as $ig) {
	die("$action '$ipnum' might be a bad idea.\n") if $ipnum =~ m/$ig/;
}

// Create a MySQL timestamp, in GMT
($month, $day, $year, $hour, $minute, $second) = (gmtime())[4,3,5,2,1,0];
$year += 1900; # Fix to 4-digit year;
$month++; # Adjust 0-based month number
$now = sprintf('%4d-%02d-%02d %02d:%02d:%02d',$year,$month,$day,$hour,$minute,$second);

if ($delete) {
	dbdel($ipnum);
	exit(0);
} 

// Add/Update the record for the IP
dbupdate($ipnum);

// Either add or update an IP number in the database
function dbupdate($ipnum) {

	if ($count = dbfind($ipnum)) {
		$count++;
		$sql = "UPDATE $dbtable SET lastaccess = '$now', counter = $count WHERE ipnum = '$ipnum'";
		$dbh->do($sql);
	} else {
		dbadd($ipnum);
		$count++;
	}

	print "Seen $count times.\n";
}

// Add an IP number to the database
function dbadd($ipnum) {

	$sql = "INSERT INTO $dbtable (ipnum, added, lastaccess, counter) VALUES ('$ipnum','$now','$now',1)";
	$dbh->do($sql);
}

// Returns true if a IP number already exists in the database
function dbfind($ipnum) {

	$sql = "SELECT counter FROM $dbtable WHERE ipnum = '$ipnum'";
	
	$sth = $dbh->prepare($sql);
	$result = $sth->execute();

	($count) = $sth->fetchrow_array();

	$sth->finish;

	return $count - 0;
}

// Delete a record
function dbdel($ipnum) {

	$sql = "DELETE FROM $dbtable WHERE ipnum = '$ipnum'";
	$dbh->do($sql);
}

 * ...
 *
 ****** THIS CODE IS UNFINISHED *******
 */

?>